#include <iostream>
#include "Resizable_deque.h"

// Every C++ Project in Visual Studio and other IDEs can only have one file with a main() function.
// Thus, if you want this to compile, you must change the name to 'main()' and change the name of
// the 'main()' function in the driver to something else.
int mmain() {
	Resizable_deque<int> list(12);

	std::cout << "The list should be empty (1): " << list.empty() << std::endl;
	std::cout << "The size should be 0: " << list.size() << std::endl;
	std::cout << "The deque_size and array_capacity should be 0 and 16 resp!: " << (list.size()) << " " << (list.capacity()) << std::endl;

	list.push_front( 5 );

	std::cout << "My ifront for 1st push is: " << list.front() << std::endl;
	std::cout << "My iback for 1st back is: " << list.back() << std::endl;

	for (int j = 0; j < list.front_position(); j++) {
		std::cout << " " << list.retreive(j);
	}

	for (int i = list.front_position(); i < list.capacity(); i++) {
		std::cout << " " << list.retreive(i);
	}

	list.push_back(10);

	list.push_front(56);
	list.push_back(12);

	list.push_front(13);
	list.push_back(9);

	list.push_back(123);
	list.push_back(91);
	list.push_front(92);
	list.push_back(93);

	std::cout << "My ifront for 1st push is: " << list.front() << std::endl;
	std::cout << "My iback for 1st back is: " << list.back() << std::endl;

	for (int j = 0; j < list.front_position(); j++) {
		std::cout << " " << list.retreive(j);
	}

	for (int i = list.front_position(); i < list.capacity(); i++) {
		std::cout << " " << list.retreive(i);
	}

	std::cout << std::endl;

	list.push_back(17);
	list.push_front(1);

	list.push_back(129);
	list.push_back(89);
	list.push_front(47);

	list.push_back(49);

	list.push_back(33); //17t element

	list.push_back(39);
	list.push_front(590);
	list.push_front(101);
	list.push_back(103);

	list.push_back(1121);
	list.push_back(66);
	list.push_front(2);
	list.push_back(93);

	list.push_back(17);
	list.push_front(1);

	list.push_back(129);
	list.push_back(89);
	list.push_front(47);

	list.push_front(123);
	list.push_front(135);

	list.push_back(69);
	list.push_front(70);

	for (int j = 0; j < list.front_position(); j++) {
		std::cout << " " << list.retreive(j);
	}

	for (int i = list.front_position(); i < list.capacity(); i++) {
		std::cout << " " << list.retreive(i);
	}

	list.pop_front();
	list.pop_front();
	list.pop_front();
	list.pop_front();
	list.pop_front();
	list.pop_front();
	list.pop_front();
	list.pop_front();
	list.pop_front();
	list.pop_front();
	list.pop_front();
	list.pop_front();
	list.pop_back();
	list.pop_back();
	list.pop_back();
	list.pop_back();
	list.pop_back();
	list.pop_front();

	std::cout << std::endl;

	for (int j = 0; j < list.front_position(); j++) {
		std::cout << " " << list.retreive(j);
	}

	for (int i = list.front_position(); i < list.capacity(); i++) {
		std::cout << " " << list.retreive(i);
	}

	std::cout << std::endl;
	std::cout << "Going to pop 8th element!" << std::endl;
	std::cout << std::endl;

	//list.pop_back();     //8th element*/

	/*std::cout << std::endl;
	std::cout << "Here's what array looks lik after 8th element pop!" << std::endl;
	std::cout << std::endl;*/

	for (int j = 0; j < list.front_position(); j++) {
		std::cout << " " << list.retreive(j);
	}

	for (int i = list.front_position(); i < list.capacity(); i++) {
		std::cout << " " << list.retreive(i);
	}
	//list.pop_front();
	//list.pop_front();

	std::cout << "My ifront is: " << list.front() << std::endl;
	std::cout << "My iback is: " << list.back() << std::endl;

	std::cout << "The size is: " << list.size() << std::endl;
	std::cout << "The array capacity is: " << list.capacity() << std::endl;

	std::cout << "The position of ifront is: " << list.front_position() << std::endl;
	std::cout << "The position of iback is: " << list.back_position() << std::endl;

	std::cout << std::endl;

	for (int j = 0; j < list.front_position(); j++) {
		std::cout <<" "<< list.retreive(j);
	}

	for (int i = list.front_position(); i < list.capacity(); i++) {
		std::cout << " "<<list.retreive(i);
	}
	

	//TESTING CLEAR FUNCTION 

	/*list.clear();

	std::cout << std::endl;
	std::cout << "Here's what array looks like after clear()!" << std::endl;
	std::cout << std::endl;

	for (int j = 0; j < list.front_position(); j++) {
		std::cout << " " << list.retreive(j);
	}

	for (int i = list.front_position(); i < list.capacity(); i++) {
		std::cout << " " << list.retreive(i);
	}

	std::cout << "The size is: " << list.size() << std::endl;
	std::cout << "The array capacity is: " << list.capacity() << std::endl;

	std::cout << "The position of ifront is: " << list.front_position() << std::endl;
	std::cout << "The position of iback is: " << list.back_position() << std::endl;

	std::cout << std::endl;*/


	//TESTING COPY CONSTRUCTOR

	Resizable_deque<int> list2 = list;

	std::cout << std::endl;
	std::cout << "This is output of copy constructor: " << std::endl;
	std::cout << std::endl;

	for (int j = 0; j < list.front_position(); j++) {
		std::cout << " " << list2.retreive(j);
	}

	for (int i = list.front_position(); i < list.capacity(); i++) {
		std::cout << " " << list2.retreive(i);
	}
	std::cout << std::endl;

	std::cout << "My ifront is: " << list.front() << std::endl;
	std::cout << "My iback is: " << list.back() << std::endl;

	std::cout << "The size is: " << list.size() << std::endl;
	std::cout << "The array capacity is: " << list.capacity() << std::endl;

	list.clear();

	std::cout << std::endl;
	std::cout << "Here's what array looks like after clear()!" << std::endl;
	std::cout << std::endl;

	for (int j = 0; j < list.front_position(); j++) {
		std::cout << " " << list.retreive(j);
	}

	for (int i = list.front_position(); i < list.capacity(); i++) {
		std::cout << " " << list.retreive(i);
	}

	std::cout << "The size is: " << list.size() << std::endl;
	std::cout << "The array capacity is: " << list.capacity() << std::endl;

	std::cout << "The position of ifront is: " << list.front_position() << std::endl;
	std::cout << "The position of iback is: " << list.back_position() << std::endl;


	return 0;
}
